src/posts/api/urls.py
from django.conf.urls import url
from .views import PostCreateAPIView, PostDeleteAPIView, PostListAPIView, PostDetailAPIView, PostUpdateAPIView


urlpatterns = [
    url(r'^$', PostListAPIView.as_view(), name='list'),
    url(r'^create/$', PostCreateAPIView.as_view(), name='create'),
    url(r'^(?P<slug>[\w-]+)/$', PostDetailAPIView.as_view(), name='detail'),
    url(r'^(?P<slug>[\w-]+)/edit/$', PostUpdateAPIView.as_view(), name='update'),
    url(r'^(?P<slug>[\w-]+)/delete/$', PostDeleteAPIView.as_view(), name='delete'),

]

src/posts/urls.py
from django.conf.urls import url
from . import views


urlpatterns = [
    url(r'^$', views.posts_list, name='list'),
    url(r'^create/$', views.posts_create),
    url(r'^(?P<slug>[\w-]+)/$', views.posts_detail, name='detail'),
    url(r'^(?P<slug>[\w-]+)/edit/$', views.posts_update, name='update'),
    url(r'^(?P<slug>[\w-]+)/delete/$', views.posts_delete, name='delete'),

]

src/trydjango19/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from accounts.views import login_view, register_view, logout_view


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^comments/', include("comments.urls", namespace="comments")),
    url(r'^login/', login_view, name='login'),
    url(r'^register/', register_view, name='register'),
    url(r'^logout/', logout_view, name='logout'),
    url(r'^', include("posts.urls", namespace="posts")),
    url(r'^api/posts/', include("posts.api.urls", namespace="posts-api")),
    url(r'^api/comments/', include("comments.api.urls", namespace="comments-api")),

]
if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/posts/models.py
from __future__ import unicode_literals


from django.core.urlresolvers import reverse
from django.db import models
from django.db.models.signals import pre_save
from django.conf import settings
from django.utils.text import slugify
from django.utils import timezone
from markdown_deux import markdown
from django.utils.safestring import mark_safe
from comments.models import Comment
from django.contrib.contenttypes.models import ContentType
from .utils import get_read_time


class PostManager(models.Manager):

    def active(self, *arg, **kwargs):
        return super(PostManager, self).filter(draft=False).filter(publish__lte=timezone.now())

def upload_location(instance, filename):
    #filebase, extension = filename.split(".")
    #return "%s/%s.%s" %(instance.id, instance.id, extension)
    return "%s/%s" %(instance.id, filename)

class Post(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, default=1)
    title = models.CharField(max_length=120)
    slug = models.SlugField(unique=True)
    image = models.ImageField(upload_to=upload_location,
            null=True,
            blank=True,)
    height_field = models.IntegerField(default=0)
    width_field = models.IntegerField(default=0)
    content = models.TextField()
    draft = models.BooleanField(default=False)
    publish = models.DateField(auto_now=False, auto_now_add=False)
    read_time = models.IntegerField(default=0)
    updated = models.DateTimeField(auto_now=True, auto_now_add=False)
    timestamp = models.DateTimeField(auto_now=False, auto_now_add=True)
    objects = PostManager()

    def __unicode__(self):
        return self.title

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse("posts:detail", kwargs={"slug": self.slug})

    def get_markdown(self):
        content = self.content
        return mark_safe(markdown(content))

    @property
    def comments(self):
        instance = self
        qs = Comment.objects.filter_by_instance(instance)
        return qs

    @property
    def get_content_type(self):
        instance = self
        content_type = ContentType.objects.get_for_model(instance.__class__)
        return content_type

    class Meta:
        ordering = ["-timestamp", "-updated"]



def create_slug(instance, new_slug=None):
    slug = slugify(instance.title)
    if new_slug is not None:
        slug = new_slug
    qs = Post.objects.filter(slug=slug).order_by("-id")
    exists = qs.exists()
    if exists:
        new_slug = "%s-%s" %(slug, qs.first().id)
        return create_slug(instance, new_slug=new_slug)
    return slug


def pre_save_post_receiver(sender, instance, *args, **kwargs):
    if not instance.slug:
        instance.slug = create_slug(instance)
    if instance.content:
        html_string = instance.get_markdown()
        read_time = get_read_time(html_string)
        instance.read_time = read_time



pre_save.connect(pre_save_post_receiver, sender=Post)

src/posts/forms.py
from django import forms
from .models import Post
from pagedown.widgets import PagedownWidget


class PostForm(forms.ModelForm):
    content = forms.CharField(widget=PagedownWidget(show_preview=False))
    publish = forms.DateField(widget=forms.SelectDateWidget)
    
    class Meta():
        model = Post
        fields = ['title', 'content', 'image', 'publish', 'draft']

src/posts/api/views.py
from rest_framework.generics import CreateAPIView, DestroyAPIView, ListAPIView, RetrieveAPIView, UpdateAPIView, RetrieveUpdateAPIView
from posts.models import Post
from .serializers import PostListSerializer, PostCreateUpdateSerializer, PostDetailSerializer
from rest_framework.permissions import AllowAny, IsAuthenticated, IsAdminUser, IsAuthenticatedOrReadOnly
from .permissions import IsOwnerOrReadOnly
from django.db.models import Q
from rest_framework.filters import SearchFilter, OrderingFilter
from rest_framework.pagination import LimitOffsetPagination, PageNumberPagination
from .pagination import PostLimitOffsetPagination, PostPageNumberPagination

class PostDetailAPIView(RetrieveAPIView):

    queryset = Post.objects.all()
    serializer_class = PostDetailSerializer
    lookup_field = 'slug'

class PostUpdateAPIView(RetrieveUpdateAPIView):

    queryset = Post.objects.all()
    serializer_class = PostCreateUpdateSerializer
    lookup_field = 'slug'
    permission_classes = [IsAuthenticatedOrReadOnly, IsOwnerOrReadOnly]

    def perform_update(self, serializer):
        serializer.save(user=self.request.user)

class PostDeleteAPIView(DestroyAPIView):

    queryset = Post.objects.all()
    serializer_class = PostDetailSerializer
    lookup_field = 'slug'
    permission_classes = [IsAuthenticatedOrReadOnly, IsOwnerOrReadOnly]


class PostListAPIView(ListAPIView):

    serializer_class = PostListSerializer
    filter_backends = [SearchFilter, OrderingFilter]
    search_fields = ['title', 'content', 'user__first_name']
    pagination_class = PostPageNumberPagination
    def get_queryset(self, *args, **kwargs):
        queryset_list = Post.objects.all()
        query = self.request.GET.get("q")
        if query:
            queryset_list = queryset_list.filter(Q(content__icontains=query)).distinct()
        return queryset_list

class PostCreateAPIView(CreateAPIView):

    queryset = Post.objects.all()
    serializer_class = PostCreateUpdateSerializer
    permission_classes = [ IsAuthenticated, ]

    def perform_create(self, serializer):
        serializer.save(user=self.request.user)

src/posts/views.py
from django.shortcuts import redirect, render, get_object_or_404
from django.contrib import messages
from .models import Post
from .forms import PostForm
from django.http import HttpResponseRedirect, Http404
from django.db.models import Q
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from django.utils import timezone
from comments.models import Comment
from comments.forms import CommentForm
from django.contrib.contenttypes.models import ContentType


def posts_create(request):
    if not request.user.is_staff or not request.user.is_superuser:
        raise Http404
    form = PostForm(request.POST or None, request.FILES or None)
    if form.is_valid():
        instance = form.save(commit=False)
        instance.save()
        instance.user = request.user
        messages.success(request, "Created!")
        return HttpResponseRedirect(instance.get_absolute_url())
    context = {
        "form": form,
    }
    return render(request, 'post_form.html', context)

def posts_detail(request, slug=None):
    instance = get_object_or_404(Post, slug=slug)
    if instance.publish > timezone.now().date() or instance.draft:
        if not request.user.is_staff or not request.user.is_superuser:
            raise Http404
    comments = instance.comments
    initial_data = {'content_type': instance.get_content_type, 'object_id': instance.id,}
    form = CommentForm(request.POST or None, initial=initial_data)
    if form.is_valid() and request.user.is_authenticated():
        c_type = form.cleaned_data.get('content_type')
        obj_id = form.cleaned_data.get('object_id')
        content_type = ContentType.objects.get(model=c_type)
        content_data = form.cleaned_data.get('content')
        parent_obj = None
        try:
            parent_id = int(request.POST.get('parent_id'))
        except:
            parent_id = None
        if parent_id:
            parent_qs = Comment.objects.filter(id=parent_id)
            if parent_qs.exists() and parent_qs.count() == 1:
                parent_obj = parent_qs.first()
        new_comment, created = Comment.objects.get_or_create(
            user = request.user,
            content_type = content_type,
            object_id = obj_id,
            content = content_data,
            parent = parent_obj,
        )
        return HttpResponseRedirect(new_comment.content_object.get_absolute_url())
    context = {
        'instance': instance,
        'comments': comments,
        'comment_form': form,
    }
    return render(request, 'post_detail.html', context)

def posts_list(request):
    today = timezone.now().date()
    object_list = Post.objects.active()
    if  request.user.is_staff or request.user.is_superuser:
        object_list = Post.objects.all()
    query = request.GET.get('q')
    if query:
        object_list = object_list.filter(Q(title__icontains=query)|Q(user__username__icontains=query)).distinct()
    paginator = Paginator(object_list, 2)
    page = request.GET.get('page')
    try:
        objects = paginator.page(page)
    except PageNotAnInteger:
        # If page is not an integer, deliver first page.
        objects = paginator.page(1)
    except EmptyPage:
        # If page is out of range (e.g. 9999), deliver last page of results.
        objects = paginator.page(paginator.num_pages)

    context = {
        'object_list': objects,
        'today': today
    }
    return render(request, 'posts_list.html', context)

def posts_update(request, slug=None):
    if not request.user.is_staff or not request.user.is_superuser:
        raise Http404
    instance = get_object_or_404(Post, slug=slug)
    form = PostForm(request.POST or None,  request.FILES or None, instance=instance)
    if form.is_valid():
        instance = form.save(commit=False)
        instance.save()
        messages.success(request, "Saved!")
        return HttpResponseRedirect(instance.get_absolute_url())
    context = {
        "form": form,
        "instance": instance,
        "form": form,
    }
    return render(request, 'post_form.html', context)

def posts_delete(request, slug=None):
    if not request.user.is_staff or not request.user.is_superuser:
        raise Http404
    instance = get_object_or_404(Post, slug=slug)
    instance.delete()
    messages.success(request, "Deleted!")
    return redirect("post:list")

src/templates/base.html
{% load staticfiles %}
<!--DOCTYPE html -->
<html>
  <head>
      <title> {% block head_title %} Try Django 1.9 {% endblock head_title %}</title>

      <!-- Latest compiled and minified CSS -->
      <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

      <!-- Optional theme -->
      <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">

<link rel='stylesheet' href='{% static "css/base.css" %}' />
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css"/>
      {% block head_extra %} {% endblock head_extra %}
  </head>


  <body>
    <div id="fb-root"></div>
<script>(function(d, s, id) {
  var js, fjs = d.getElementsByTagName(s)[0];
  if (d.getElementById(id)) return;
  js = d.createElement(s); js.id = id;
  js.src = "//connect.facebook.net/pl_PL/sdk.js#xfbml=1&version=v2.8";
  fjs.parentNode.insertBefore(js, fjs);
}(document, 'script', 'facebook-jssdk'));</script>
    {% include "messages_display.html" %}
    <div class='container'>
      <ol class='breadcrumb'>
        <li><a href="{% url 'posts:list' %}">Home</a></li>
        {% block post_detail_link %}
        {% endblock post_detail_link %}
        {% if not request.user.is_authenticated %}
        <li class="pull-right"><a href="{% url 'register' %}">Register</a></li>
        <li class="pull-right"><a href="{% url 'login' %}">Login</a></li>
        {% else %}
        <li class="pull-right"><a href="{% url 'logout' %}">Logout</a></li>
        {% endif %}
      </ol>
      {% block content %}

      {% endblock content %}
    </div>
    <script
			  src="https://code.jquery.com/jquery-1.12.4.min.js"
			  integrity="sha256-ZosEbRLbNQzLpnKIkEdrPv7lOy9C27hHQ+Xp8a4MxAQ="
			  crossorigin="anonymous"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/marked/0.3.6/marked.min.js"></script>
    <script type="text/javascript">
    $(document).ready(function(){
        $(".content-markdown").each(function(){
            var content = $(this).text()
            var markedContent = marked(content)
            $(this).html(markedContent)
      })
      $(".post-detail-item img").each(function(){
           $(this).addClass("img-responsive")
    })

    var contentInput = $('#id_content')

    function setContent(value){
         var markedContent = marked(value)
         $('#preview-content').html(markedContent)
         $('#preview-content img').each(function(){
             $(this).addClass('img-responsive')

         })
    }
    setContent(contentInput.val())
    contentInput.keyup(function(){
        var newContent = $(this).val()
        setContent(newContent)

    })
    var titleInput = $('#id_title')
    function setTitle(value){
      $('#preview-title').text(value)
    }
    setTitle(titleInput.val())
    $('#preview-title').text(titleInput.val())
    titleInput.keyup(function(){
      var newContent = $(this).val()
      setTitle(newContent)
    })
    $('.comment-reply-btn').click(function(event){
        event.preventDefault();
        $(this).parent().next('.comment-reply').fadeToggle();
    })

    })
    </script>
  </body>
</html>

src/templates/comment_thread.html
{% extends 'base.html' %}
{% load urlify %}
{% load crispy_forms_tags %}
{% block head_title %} {{ instance.title }} | {{ block.super }} {% endblock head_title %}

{% block content %}
<div class="col-sm-6 col-sm-offset-3">


      <p>{{ comment.content }}</p>
      <footer> via {{ comment.user }} | {{ comment.timestamp|timesince }} ago |
        {% if comment.children.count > 0 %}{{comment.children.count}} Comments {% endif %}
      {% if request.user == comment.user %} Delete {% endif %}<a href='{{ comment.get_delete_url }}'> Delete </a>
      </footer>
      <hr/>
      <div>
      {% for child_comment in comment.children %}
         <blockquote>
             <p>{{ child_comment.content }}</p>
             <footer> via {{ child_comment.user }} | {{ child_comment.timestamp|timesince }} ago
                {% if request.user == child_comment.user %}<a href='{{ child_comment.get_delete_url }}'> Delete </a>{% endif %}
             </footer>

         </blockquote>
     {% endfor %}
     {% if request.user.is_authenticated %}
        <form method="POST" action="."> {% csrf_token %}
            {{ comment_form|crispy }}
            <input type="hidden" name='parent_id' value='{{ comment.id }}'/>
            <input type="submit" value='Reply' class="btn btn-default"/>
        </form>
        {% else %}
        <p> You must login to comment</p>
        {% endif %}
      </div>
  <hr/>

</div>
{% endblock content %}

src/templates/confirm_delete.html
{% extends 'base.html' %}
{% load urlify %}
{% load crispy_forms_tags %}
{% block head_title %} {{ instance.title }} | {{ block.super }} {% endblock head_title %}

{% block content %}
<div class="col-sm-6 col-sm-offset-3">
  <h1> Confirm delete</h1>

        <form method="POST" action="."> {% csrf_token %}
            <p> Are you sure you want to delete: {{ object.content }} ? </p>
            <input type="submit" value='Confirm' class="btn btn-warning"/>
            <a href='{{ object.get_absolute_url }}' class="btn btn-default"/>Cancel</a>

        </form>
      </div>
  <hr/>

</div>
{% endblock content %}

src/templates/form.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}

{% block content %}
<div class="col-sm-6 col-sm-offset-3">
<h1>{{title}}</h1>

    <form method="POST" action="" enctype="multipart/form-data">{% csrf_token %}
      {{form|crispy}}
      <input type="submit" class='btn btn-default' value="{{ title }}" />
    </form>
</div>
{% endblock content %}

src/templates/messages_display.html
{% if messages %}
  <div class="messages">
      <ul class="messages">
          {% for message in messages %}
            <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
          {% endfor %}
  </div>
{% endif %}

src/templates/post_detail.html
{% extends 'base.html' %}
{% load urlify %}
{% load crispy_forms_tags %}
{% block head_title %} {{ instance.title }} | {{ block.super }} {% endblock head_title %}
{% block post_detail_link %}
<li> <a href="{{ instance.get_absolute_url }}">{{ instance.title }}</a></li>
{% endblock post_detail_link %}
{% block content %}
<div class="col-sm-6 col-sm-offset-3">
  {% if instance.image %}
  <img src="{{ instance.image.url }}" class="img-responsive"/>
  {% endif %}
  <h1>{{ instance.title}} <small>{% if instance.draft %}<span style='color:red;'>Draft </span>{% endif %}{{ instance.publish }}</small></h1>
  <p>Author: {{ instance.user }} </p>
  <p>Read time: {{ instance.read_time }} minutes</p>
<div class="fb-like" data-href="https://developers.facebook.com/docs/plugins/" data-layout="standard" data-action="like" data-show-faces="true" data-share="true"></div>
  </p>
  <!-- <p><a href="https://www.facebook.com/sharer/sharer.php?u={{ request.build_absolute_uri }}">
Share on Facebook
</a>
</p> -->
<hr/>
<br/>
<div class="post-detail-item">
  {{instance.get_markdown}}</br>
</div>
<div>
  <p class="lead">Comments</p>
  {% if request.user.is_authenticated %}
  <form method="POST" action="."> {% csrf_token %}
    {{ comment_form|crispy }}
    <input type="submit" value='Comment' class="btn btn-default"/>
  </form>
  {% else %}
  <p> You must login to comment</p>
  {% endif %}
  <hr/>
       {% for comment in comments %}
       <blockquote>
           <p>{{ comment.content }}</p>
           <footer> via {{ comment.user }} | {{ comment.timestamp|timesince }} ago |
             {% if comment.children.count > 0 %}{{comment.children.count}} Comments | {% endif %}
             <a class="comment-reply-btn" href='#'>Reply</a>
             <a class="" href='{{ comment.get_absolute_url }}'>Thread</a>
          </footer>
           <div class="comment-reply">
           {% for child_comment in comment.children %}
              <blockquote>
                  <p>{{ child_comment.content }}</p>
                  <footer> via {{ child_comment.user }} | {{ child_comment.timestamp|timesince }} ago</footer>

              </blockquote>
          {% endfor %}
          {% if request.user.is_authenticated %}
             <form method="POST" action="."> {% csrf_token %}
                 {{ comment_form|crispy }}
                 <input type="hidden" name='parent_id' value='{{ comment.id }}'/>
                 <input type="submit" value='Reply' class="btn btn-default"/>
             </form>
             {% else %}
             <p> You must login to comment</p>
             {% endif %}
           </div>
       </blockquote>
       <hr/>
       {% endfor %}
</div>
</div>
{% endblock content %}

src/templates/post_form.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block head_extra %}
{{ form.media }}
{% endblock head_extra %}

{% block content %}
<div class="col-sm-6">
  <h1>Preview</h1>
  <div class="content-preview">
<h3 id='preview-title'>  </h3>
<p id='preview-content'>  </p>
  </div>

</div>

<div class="col-sm-6">

    <form method="POST" action="" enctype="multipart/form-data">{% csrf_token %}
      {{form|crispy}}
      <input type="submit" class='btn btn-default' value="Create Post" />
    </form>
</div>
{% endblock content %}

src/templates/posts_list.html
{% extends 'base.html' %}

{% block content %}
<div class="col-sm-6 col-sm-offset-3">
  <form method="GET" action=".">
    <div class="input-group">
        <input class="form-control" type='text' name="q" placeholder="search posts" value="{{ request.GET.q }}"/>
        <span class="input-group-btn">
          <button class='btn btn-default' type="submit" value="search"/>Search <i class="fa fa-search"></i></button>
        </span>
    </div>
  </form>
{% for obj in object_list %}
<div class="row">
  <div class="col-sm-12">
    <div class="thumbnail">
      {% if obj.image %}
      <img src="{{ obj.image.url }}" class="img-responsive"/>
      {% endif %}
      <div class="caption post-detail-item">
        <h3>{% if obj.draft %}<span style='color:red;'>Draft </span>{% endif %}{% if obj.publish > today %}Future Post{% endif %}</h3>
        <h3>  <a href='{{ obj.get_absolute_url }}'>{{obj.title}}</a><small>  {{obj.publish}}</small></h3>
        <p>Author: {{ obj.user }} </p>
        {{obj.get_markdown|truncatechars_html:30}}
        <p><a href="{{ obj.get_absolute_url }}" class="btn btn-primary" role="button">View</a> </p>
      </div>
    </div>
  </div>
</div>
<hr/>
{% endfor %}
<div class="pagination">
    <span class="step-links">
        {% if object_list.has_previous %}
            <a href="?page={{ object_list.previous_page_number }} {% if request.GET.q %} & q={{ request.GET.q}} {% endif %}">previous</a>
        {% endif %}

        <span class="current">
            Page {{ object_list.number }} of {{ object_list.paginator.num_pages }}.
        </span>

        {% if object_list.has_next %}
            <a href="?page={{ object_list.next_page_number }} {% if request.GET.q %} & q={{ request.GET.q}} {% endif %}">next</a>
        {% endif %}
    </span>
</div>
</div>
{% endblock content %}